import java.math.BigInteger
import java.util.*

object DiffieHellman {

    fun privateKey(prime: BigInteger): BigInteger {
        var returnVal: BigInteger
        val random = Random()
        do {
            returnVal = BigInteger.probablePrime(random.nextInt(prime.bitLength()).coerceAtLeast(2), random)
        } while (returnVal >= prime && returnVal != 0.toBigInteger())
        return returnVal
    }

    fun publicKey(p: BigInteger, g: BigInteger, privKey: BigInteger): BigInteger {
        return g.modPow(privKey, p)
    }

    fun secret(prime: BigInteger, publicKey: BigInteger, privateKey: BigInteger): BigInteger {
        return publicKey.modPow(privateKey, prime)
    }
}
